#!/usr/bin/env python

import re, sys

packages_to_install = []
packages_to_remove = []

def _add_package(line, remove=False):
  try: package = re.search('^\s*?([^#]+)', line[2:]).group(1).strip()
  except AttributeError: return
  else:
    release = ''
    if '/' in package:
      package, release = package.split('/')
    if package.startswith('-'):
      packages_to_remove.append(package[1:])
    else:
      packages_to_install.append((package.lstrip('+'), release))

lines = sys.stdin.read()
skip_invalid_file = True
for line in lines:
  if line.startswith('diff '):  # set next diff-ed file
    if re.search('config/package\-lists/[^/]*?\.list\b', line):
      skip_invalid_file = False
    else:
      skip_invalid_file = True
  elif skip_invalid_file:         # process changes in last set file
    if line.startswith('> '):     # additions
      _add_package(line)
    elif line.startswith('< '):   # deletions
      _add_package(line, remove=True)