#!/bin/bash

DIR=$PWD

alias stripansicolors='sed "s,\x1B\[[0-9;]*[a-zA-Z],,g"'

function set_difference {
  echo $(comm -23 <(echo "$1" | sort -u) <(echo "$2" | sort -u))
}

PACKAGES_TO_INSTALL=$(grep -PRoh -d skip '^[^\s #]+' ${DIR}/*.list | stripansicolors | sort -u)
PACKAGES_LINE=$(echo "$PACKAGES_TO_INSTALL" | tr '\n' ' ')
RECURSIVE_DEPENDS=$(apt-rdepends $PACKAGES_LINE | grep Depends | stripansicolors | awk '{print $2}' | sort -u)
RECURSIVE_RECOMMENDS=$(apt-rdepends --follow=Recommends --show=Recommends $PACKAGES_LINE | grep -oP '^\w+' | stripansicolors | sort -u)
# but strip original packages
RECURSIVE_DEPENDS=$(set_difference "$RECURSIVE_DEPENDS" "$PACKAGES_TO_INSTALL")
RECURSIVE_RECOMMENDS=$(set_difference "$RECURSIVE_RECOMMENDS" "$PACKAGES_TO_INSTALL")

#~ ALL_THEIR_DEPENDS=$(apt-cache depends $PACKAGES_TO_INSTALL)
#~ RECURSIVE_RECOMMENDS=$(apt-rdepends -f Recommends $PACKAGES_TO_INSTALL | grep Depends | awk '{print $2}' | sort -u')
#~ ALL_THEIR_RECOMMENDS=$(echo $ALL_THEIR_RELATIONS | grep Recommends | sort -u | awk '{ print $2; }')

echo $(set_difference "$RECURSIVE_RECOMMENDS" "$RECURSIVE_DEPENDS")


# dctrl-tools seemed too much work :